# Docker image to use
image: "ubuntu:18.04"


build:

  stage: build

  script:

    # Update packages list
    - apt-get update

    # Install packages to build image
    - |
      apt-get install --yes --no-install-recommends \
        build-essential \
        ca-certificates \
        file \
        gawk \
        gettext \
        git \
        gosu \
        g++ \
        libncurses5-dev \
        libssl-dev \
        make \
        man-db \
        python \
        rsync \
        subversion \
        sudo \
        time \
        unzip \
        wget \
        zip \
        zlib1g-dev

    # Build bootloader and openwrt
    - ./build

    # Prepare artifacts to collect
    - mkdir $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/

    # Uboot
    - cp -r ./uboot/out/bin/ $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/uboot

    # Image to flash directly
    - cp -r ./image/ $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/

    # Openwrt
    - cp -r ./openwrt/out/bin/targets/ar71xx/generic/ $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/openwrt

    # Upgrade script
    - cp -r ./openwrt/upgrade $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/openwrt/

    # Install script and configuration
    - cp -r ./openwrt/install $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/openwrt/
    - cp -r ./openwrt/root/ $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/openwrt/
    - cp -r ./openwrt/secret/ $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/openwrt/

    # Extroot
    - cp -r ./openwrt/extroot/ $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/openwrt/

    # Symlinks
    - ln -s ./openwrt/upgrade $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/
    - ln -s ./openwrt/install $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/

  artifacts:
    name: $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA
    paths:
      - $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA/
